
/************************************************
*                                               *
*        Copyright (c) Alexandr Oshurkov        *
*                                               *
*    http://www.softonic.narod.ru/index.html    *
*                                               *
*              softonic@narod.ru                *
*                                               *
*************************************************/

#if !defined(AFX_AXCDManager_H__1AA3A52E_6A6A_4DA8_9F38_D6810717F780__INCLUDED_)
#define AFX_AXCDManager_H__1AA3A52E_6A6A_4DA8_9F38_D6810717F780__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <mmsystem.h>
#include <AxThread.h>

#pragma comment(lib, "winmm.lib")

namespace AxWinLib {

//-------------------------------------------------------------
//	Return true if disk present on CD/DVD drive
//	Note: some drives will spin up CD/DVD disk
bool IsCDPresent(TCHAR chDriveName);

//-------------------------------------------------------------
class CCDThread : public CAxThread
{
	TCHAR   m_chDriveName;
	bool    m_bOpen;
	bool*   m_pMediaStatus;

protected:

	virtual DWORD Execute();

public:

	CCDThread();
	virtual ~CCDThread();
	bool Create(TCHAR chDirveName, bool bOpen, bool* pMediaStatus);
};

typedef std::auto_ptr<CCDThread> TThreadPtr;

//-------------------------------------------------------------
class CAxCDManager  
{
	enum { MAX_DRIVES = 27 };
	
	TThreadPtr  m_aCDThreads[MAX_DRIVES];
	TCHAR       m_aCDLetters[MAX_DRIVES];
	bool        m_aOpenStatus[MAX_DRIVES];
	bool        m_aMediaStatus[MAX_DRIVES];
	int         m_iDrivesCount;
	int         m_iCurrDrive;

protected:

	bool OpenCloseCd(int iDrive, bool bOpen, bool* pMediaStatus = 0);
	int  GetCDLetters(char *pLetters, int iSize) const;

public:

	TCHAR GetDriveName(int iDrive) const;
	TCHAR GetSelectedDrive() const;
	bool  SelectDrive(int iDrive);
	bool  SelectDrive(TCHAR chDrive);
	bool  IsOpened() const;
	bool  IsCDPresent() const;
	bool  IsRunning() const;
	bool  Open();
	bool  Close(bool bDetectCD = false);
	bool  OpenClose(bool bDetectCD = false);
	void  RefreshState();

	int GetDrivesCount() const;

	CAxCDManager();
	CAxCDManager(bool bUseScrlLock);
	virtual ~CAxCDManager();
	TCHAR operator[] (int i) const;

#if _MSC_VER>=1200
	__declspec(property(get=GetDrivesCount)) int DrivesCount;
#endif

};

}

#endif // !defined(AFX_AXCDManager_H__1AA3A52E_6A6A_4DA8_9F38_D6810717F780__INCLUDED_)
