/************************************************
*                                               *
*        Copyright (c) Alexandr Oshurkov        *
*                                               *
*    http://www.softonic.narod.ru/index.html    *
*                                               *
*              softonic@narod.ru                *
*                                               *
*************************************************/

#if !defined(AFX_AXTHREAD_H__A122A7E2_20C2_4976_B31B_D5500168AE27__INCLUDED_)
#define AFX_AXTHREAD_H__A122A7E2_20C2_4976_B31B_D5500168AE27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>

namespace AxWinLib {

class CAxThread  
{
	HANDLE m_hHandle;
	DWORD  m_dwID;
	bool   m_bDoExit;

protected:
	virtual void ResetMembers();

public:
	enum TExitCodes { SUCCESS, TERMINATED, CANCELED, UNKNOWN};
	HANDLE GetHandle() const;
	DWORD  GetID() const;

	CAxThread();
	virtual ~CAxThread();

//	Creating thread suspened or not
	virtual bool Create(bool bSuspended = false);

//	Return true if the thread is running,
//	or false if the thread is not running
	bool IsRunning() const;
//	Return true if the m_bDoExit equal true
	bool IsRequestExit() const;

//	Resume thread execution
	void Resume();
//	Suspending thread
	void Suspend();
//	Stop thread execution
	void Terminate();
//	Requesting terminate the thread
	void SoftTerminate();

//	Main thread function
	virtual DWORD Execute() = 0;

	operator HANDLE();
	bool operator==(const CAxThread& refThread) const;

#if _MSC_VER >= 1200
	__declspec(property(get = GetHandle)) HANDLE Handle;
	__declspec(property(get = GetID)) DWORD ID;
#endif

};
}

#endif // !defined(AFX_AXTHREAD_H__A122A7E2_20C2_4976_B31B_D5500168AE27__INCLUDED_)
